<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:sch="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2">
    <param xmlns="http://www.w3.org/1999/XSL/Transform" name="datafiles_directory" />
    <ns prefix="xccdf" uri="http://checklists.nist.gov/xccdf/1.1"/>
    <ns prefix="xml" uri="http://www.w3.org/XML/1998/namespace"/>
    <ns prefix="oval-def" uri="http://oval.mitre.org/XMLSchema/oval-definitions-5"/>
    <ns prefix="oval-com" uri="http://oval.mitre.org/XMLSchema/oval-common-5"/>
    <ns prefix="scap" uri="http://scap.nist.gov/schema/data-stream/0.1"/>
    <ns prefix="cpe-dict" uri="http://cpe.mitre.org/dictionary/2.0"/>
    <ns prefix="xcf" uri="nist:scap:xslt:function"/>
    <ns prefix="nvd-config" uri="http://scap.nist.gov/schema/feed/configuration/0.1"/>
    <ns prefix="sch" uri="http://purl.oclc.org/dsdl/schematron"/>
    <pattern id="scap-use-case-conf-verification">
        <rule id="scap-use-case-conf-verification-rule" context="xccdf:Rule">
            <assert flag="WARNING"
                test="if(not(exists(xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5']/xccdf:check-content-ref[ends-with(@href,'patches.xml')]))) then exists(xccdf:ident[@system eq 'http://cce.mitre.org' or @system eq 'cce.mitre.org/version/4']) else true()"
                id="scap-use-case-conf-verification-cce-required">20</assert>
            <assert flag="ERROR"
                test="if( exists(xccdf:ident[starts-with(.,'CCE')]) ) then exists(xccdf:ident[starts-with(.,'CCE') and @system eq 'http://cce.mitre.org']) else true()"
                id="scap-use-case-conf-verification-cce-v5">21</assert>
            <assert flag="ERROR"
                test="every $m in current()//xccdf:check-content-ref satisfies (every $n in current()/xccdf:ident[@system eq 'http://cce.mitre.org' or @system eq 'cce.mitre.org/version/4'] satisfies exists(//*[@id eq $m/@href]//*[@id eq $m/@name]//oval-def:reference[(@source eq $n/@system or @source eq 'CCE') and @ref_id eq $n]))"
                id="scap-use-case-conf-verification-cce-ref">82</assert>
        </rule>
        <rule id="scap-use-case-conf-verification-content" context="/scap:data-stream">
            <assert flag="ERROR"
                test="exists(*[ends-with(@id,'xccdf.xml') and @content-type eq 'XCCDF_BENCHMARK']) and exists(*[ends-with(@id,'oval.xml') and @content-type eq 'OVAL_COMPLIANCE']) and exists(*[ends-with(@id,'cpe-dictionary.xml') and @content-type eq 'CPE_DICTIONARY']) and exists(*[ends-with(@id,'cpe-oval.xml') and @content-type eq 'CPE_INVENTORY'])"
                id="scap-use-case-conf-verification-content-check">80</assert>
        </rule>
        <rule id="scap-use-case-conf-verification-check-content-ref"
            context="xccdf:Rule//xccdf:check-content-ref">
            <assert flag="ERROR"
                test="if( @name ) then matches(//*[@id eq current()/@href]//*[@id eq current()/@name]/@class,'^(compliance|patch)$') else true()"
                id="scap-use-case-conf-verification-rule-ref-oval">92</assert>
            <assert flag="ERROR"
                test="if( ends-with(@href,'patches.xml') ) then exists(//*[@id eq current()/@href]/@content-type eq 'OVAL_PATCH') else true()"
                id="scap-use-case-conf-verification-patch-resolvable">93</assert>
            <assert flag="ERROR"
                test="if( ends-with(@href,'patches.xml') and @name ) then matches(//*[@id eq current()/@href]//oval-def:definition[@id eq current()/@name]/@class,'^(compliance|patch)$') else true()"
                id="scap-use-case-conf-verification-patch-ref">94</assert>
        </rule>
    </pattern>
    <pattern id="scap-general-isolated-1">
        <rule id="scap-general-xccdf-lang"
            context="element()[@xml:lang and namespace-uri() eq 'http://checklists.nist.gov/xccdf/1.1']">
            <assert flag="WARNING" test="@xml:lang eq 'en-US'" id="scap-general-xccdf-lang-check"
                >2</assert>
        </rule>
    </pattern>
    <pattern id="scap-general">
        <rule id="scap-general-oval-generator" context="oval-def:generator">
            <assert id="scap-general-oval-generator-schema-version" test="matches(oval-com:schema_version,'5\.(3|4)')">A13</assert>
        </rule>
        <rule id="scap-general-xccdf-benchmark" context="xccdf:Benchmark">
            <assert flag="ERROR" test="if( @style ) then @style eq 'SCAP_1.0' else true()"
                id="scap-general-xccdf-style">4</assert>
            <assert flag="WARNING" test="exists(xccdf:metadata)"
                id="scap-general-xccdf-metadata-missing">8-1</assert>
            <assert flag="WARNING"
                test="every $m in xccdf:metadata/* satisfies $m/namespace-uri() eq 'http://purl.org/dc/elements/1.1/' and ($m/local-name() eq 'creator' or $m/local-name() eq 'publisher' or $m/local-name() eq 'contributor')"
                id="scap-general-xccdf-metadata-populated">8-2</assert>
            <assert flag="ERROR"
                test="if( count(xccdf:title) gt 1 ) then count(xccdf:title) eq count(xccdf:title[@xml:lang]) else true()"
                id="scap-general-xccdf-title-1">9-1</assert>
            <assert flag="ERROR"
                test="if( count(xccdf:title) gt 1 ) then exists(xccdf:title[@xml:lang eq 'en-US']) else true()"
                id="scap-general-xccdf-title-2">9-2</assert>
            <assert flag="ERROR" test="exists(xccdf:title)" id="scap-general-xccdf-title-3"
                >9-3</assert>
            <assert flag="ERROR"
                test="if( count(xccdf:description) gt 1 ) then count(xccdf:description) eq count(xccdf:description[@xml:lang]) else true()"
                id="scap-general-xccdf-description-1">10-1</assert>
            <assert flag="ERROR"
                test="if( count(xccdf:description) gt 1 ) then exists(xccdf:description[@xml:lang eq 'en-US']) else true()"
                id="scap-general-xccdf-description-2">10-2</assert>
            <assert flag="ERROR" test="exists(xccdf:description)"
                id="scap-general-xccdf-description-3">10-3</assert>
            <assert flag="ERROR" test="exists(xccdf:reference)"
                id="scap-general-xccdf-reference-missing">13-1</assert>
            <assert flag="WARNING"
                test="if( xccdf:reference ) then exists(xccdf:reference/@href) else true()"
                id="scap-general-xccdf-reference-populated">13-2</assert>
            <assert flag="ERROR"
                test="some $m in xccdf:platform satisfies matches($m/@idref,'[c][pP][eE]:/[AHOaho]?(:[A-Za-z0-9\._\-~%]*){0,6}')"
                id="scap-general-xccdf-benchmark-platform-cpe">14</assert>
            <assert flag="ERROR"
                test="every $m in xccdf:platform[matches(@idref,'[c][pP][eE]:/[AHOaho]?(:[A-Za-z0-9\._\-~%]*){0,6}')] satisfies exists(//cpe-dict:cpe-list/cpe-dict:cpe-item[@name eq $m/@idref])"
                id="scap-general-xccdf-benchmark-platform-cpe-reference-valid">15-1</assert>
        </rule>
        <rule id="scap-general-xccdf-status-rule-value-date" context="xccdf:status">
            <assert flag="ERROR" test=". eq 'draft' or . eq 'accepted'"
                id="scap-general-xccdf-status-rule-value-date-1">5-1</assert>
            <assert flag="WARNING" test="@date ne ''"
                id="scap-general-xccdf-status-rule-value-date-2">5-2</assert>
        </rule>
        <rule id="scap-general-oval-cpe-dict" context="cpe-dict:cpe-list/cpe-dict:cpe-item">
            <assert flag="WARNING"
                test="exists(document(concat($datafiles_directory,'/official-cpe-dictionary_v2.2.xml'))/cpe-dict:cpe-list/cpe-dict:cpe-item[count(tokenize(@name,':')) ge count(tokenize(current()/@name,':')) and (tokenize(@name,':')[1] eq tokenize(current()/@name,':')[1] or tokenize(current()/@name,':')[1] eq '' or not(exists(tokenize(current()/@name,':')[1]))) and (tokenize(@name,':')[2] eq tokenize(current()/@name,':')[2] or tokenize(current()/@name,':')[2] eq '' or not(exists(tokenize(current()/@name,':')[2]))) and (tokenize(@name,':')[3] eq tokenize(current()/@name,':')[3] or tokenize(current()/@name,':')[3] eq '' or not(exists(tokenize(current()/@name,':')[3]))) and (tokenize(@name,':')[4] eq tokenize(current()/@name,':')[4] or tokenize(current()/@name,':')[4] eq '' or not(exists(tokenize(current()/@name,':')[4]))) and (tokenize(@name,':')[5] eq tokenize(current()/@name,':')[5] or tokenize(current()/@name,':')[5] eq '' or not(exists(tokenize(current()/@name,':')[5]))) and (tokenize(@name,':')[6] eq tokenize(current()/@name,':')[6] or tokenize(current()/@name,':')[6] eq '' or not(exists(tokenize(current()/@name,':')[6]))) and (tokenize(@name,':')[7] eq tokenize(current()/@name,':')[7] or tokenize(current()/@name,':')[7] eq '' or not(exists(tokenize(current()/@name,':')[7]))) and (tokenize(@name,':')[8] eq tokenize(current()/@name,':')[8] or tokenize(current()/@name,':')[8] eq '' or not(exists(tokenize(current()/@name,':')[8])))])"
                id="scap-general-oval-cpe-dict-cpe-dict">15-2</assert>
            <assert flag="WARNING"
                test="not(exists(document(concat($datafiles_directory,'/official-cpe-dictionary_v2.2.xml'))/cpe-dict:cpe-list/cpe-dict:cpe-item[count(tokenize(@name,':')) ge count(tokenize(current()/@name,':')) and (tokenize(@name,':')[1] eq tokenize(current()/@name,':')[1] or tokenize(current()/@name,':')[1] eq '' or not(exists(tokenize(current()/@name,':')[1]))) and (tokenize(@name,':')[2] eq tokenize(current()/@name,':')[2] or tokenize(current()/@name,':')[2] eq '' or not(exists(tokenize(current()/@name,':')[2]))) and (tokenize(@name,':')[3] eq tokenize(current()/@name,':')[3] or tokenize(current()/@name,':')[3] eq '' or not(exists(tokenize(current()/@name,':')[3]))) and (tokenize(@name,':')[4] eq tokenize(current()/@name,':')[4] or tokenize(current()/@name,':')[4] eq '' or not(exists(tokenize(current()/@name,':')[4]))) and (tokenize(@name,':')[5] eq tokenize(current()/@name,':')[5] or tokenize(current()/@name,':')[5] eq '' or not(exists(tokenize(current()/@name,':')[5]))) and (tokenize(@name,':')[6] eq tokenize(current()/@name,':')[6] or tokenize(current()/@name,':')[6] eq '' or not(exists(tokenize(current()/@name,':')[6]))) and (tokenize(@name,':')[7] eq tokenize(current()/@name,':')[7] or tokenize(current()/@name,':')[7] eq '' or not(exists(tokenize(current()/@name,':')[7]))) and (tokenize(@name,':')[8] eq tokenize(current()/@name,':')[8] or tokenize(current()/@name,':')[8] eq '' or not(exists(tokenize(current()/@name,':')[8])))])) or exists(document(concat($datafiles_directory,'/official-cpe-dictionary_v2.2.xml'))/cpe-dict:cpe-list/cpe-dict:cpe-item[count(tokenize(@name,':')) ge count(tokenize(current()/@name,':')) and (tokenize(@name,':')[1] eq tokenize(current()/@name,':')[1] or tokenize(current()/@name,':')[1] eq '' or not(exists(tokenize(current()/@name,':')[1]))) and (tokenize(@name,':')[2] eq tokenize(current()/@name,':')[2] or tokenize(current()/@name,':')[2] eq '' or not(exists(tokenize(current()/@name,':')[2]))) and (tokenize(@name,':')[3] eq tokenize(current()/@name,':')[3] or tokenize(current()/@name,':')[3] eq '' or not(exists(tokenize(current()/@name,':')[3]))) and (tokenize(@name,':')[4] eq tokenize(current()/@name,':')[4] or tokenize(current()/@name,':')[4] eq '' or not(exists(tokenize(current()/@name,':')[4]))) and (tokenize(@name,':')[5] eq tokenize(current()/@name,':')[5] or tokenize(current()/@name,':')[5] eq '' or not(exists(tokenize(current()/@name,':')[5]))) and (tokenize(@name,':')[6] eq tokenize(current()/@name,':')[6] or tokenize(current()/@name,':')[6] eq '' or not(exists(tokenize(current()/@name,':')[6]))) and (tokenize(@name,':')[7] eq tokenize(current()/@name,':')[7] or tokenize(current()/@name,':')[7] eq '' or not(exists(tokenize(current()/@name,':')[7]))) and (tokenize(@name,':')[8] eq tokenize(current()/@name,':')[8] or tokenize(current()/@name,':')[8] eq '' or not(exists(tokenize(current()/@name,':')[8]))) and not(exists(@deprecated)) or @deprecated eq 'false'])"
                id="scap-general-oval-cpe-dict-deprecated">15-3</assert>
            <assert flag="ERROR"
                test="if( exists(cpe-dict:check) ) then ends-with(cpe-dict:check/@href,'cpe-oval.xml') and exists(//scap:check-system-content[@id eq current()/cpe-dict:check/@href]//oval-def:definition[@id eq current()/cpe-dict:check]) else true()"
                id="scap-general-oval-cpe-inventory">72</assert>
        </rule>
        <rule id="scap-general-xccdf-group-profile-platform" context="xccdf:Group | xccdf:Profile">
            <assert flag="ERROR"
                test="not(matches(xccdf:platform/@idref,'^[c][pP][eE]:/[AHOaho]?(:[A-Za-z0-9\._\-~%]*){0,6}$'))"
                id="scap-general-xccdf-group-profile-platform-check">16-1</assert>
        </rule>
        <rule id="scap-general-xccdf-rule" context="xccdf:Rule">
            <assert flag="ERROR"
                test="not(matches(xccdf:platform/@idref,'^[c][pP][eE]:/[AHOaho]?(:[A-Za-z0-9\._\-~%]*){0,6}$'))"
                id="scap-general-xccdf-rule-platform">16-2</assert>
            <assert flag="ERROR" test="@weight eq '10.0'"
                id="scap-general-xccdf-rule-weight-required">18</assert>
            <assert flag="ERROR"
                test="every $m in current()//* satisfies $m/namespace-uri() ne 'http://oval.mitre.org/XMLSchema/oval-definitions-5' or $m/local-name() ne 'oval_definitions'"
                id="scap-general-xccdf-oval-embedded">31</assert>
            <assert flag="ERROR"
                test="every $m in current()//xccdf:check-content-ref[(ends-with(@href,'oval.xml') or ends-with(@href,'patches.xml') or ends-with(@href,'cpe-dictionary.xml') or ends-with(@href,'cpe-oval.xml')) and not(exists(@name))] satisfies exists(//scap:check-system-content[@id eq $m/@href])"
                id="scap-general-xccdf-rule-reference-oval-resolvable">32</assert>
            <assert flag="ERROR"
                test="every $m in current()//xccdf:check-content-ref[(ends-with(@href,'oval.xml') or ends-with(@href,'patches.xml') or ends-with(@href,'cpe-dictionary.xml') or ends-with(@href,'cpe-oval.xml')) and @name] satisfies exists(//scap:check-system-content[@id eq $m/@href]//oval-def:definition[@id eq $m/@name])"
                id="scap-general-xccdf-rule-reference-oval-specific-def">33</assert>
            <assert flag="ERROR"
                test="every $m in current()//xccdf:check-content-ref[ends-with(@href,'patches.xml')] satisfies exists(//scap:check-system-content[@id eq $m/@href]/oval-def:oval_definitions)"
                id="scap-general-xccdf-rule-oval-patches-2">35</assert>
            <assert flag="ERROR"
                test="every $l in current()//xccdf:check-content-ref[@name] satisfies (every $m in xcf:get-all-parents(/,//*[@id eq $l/@href]//oval-def:definition[@id eq $l/@name])//oval-def:criterion satisfies (every $n in $m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]//*:state satisfies (every $o in $n/ancestor::oval-def:oval_definitions//*[@id eq $n/@state_ref]//*[@var_ref] satisfies (every $p in xcf:get-all-external-vars($o/ancestor::oval-def:oval_definitions,$o) satisfies exists($l/preceding-sibling::xccdf:check-export[@export-name eq $p/@id])))))"
                id="scap-general-xccdf-rule-oval-variable-binding">37</assert>
        </rule>
        <rule id="scap-general-xccdf-ident" context="xccdf:ident">
            <assert flag="WARNING"
                test="if( @system eq 'http://cce.mitre.org') then exists(document(concat($datafiles_directory,'/nvdcce-0.1-feed.xml'))/nvd-config:nvd/nvd-config:entry[@id eq current()]) else true()"
                id="scap-general-xccdf-ident-cce-exists">74|<sch:value-of select="."/></assert>
        </rule>
        <rule id="scap-general-xccdf-no-complex-check" context="//xccdf:complex-check">
            <assert flag="ERROR" test="false()" id="scap-general-xccdf-no-complex-check-check"
                >24</assert>
        </rule>
        <rule id="scap-general-xccdf-no-check-content" context="//xccdf:check-content">
            <assert flag="ERROR" test="false()" id="scap-general-xccdf-no-check-content-check"
                >25</assert>
        </rule>
        <rule id="scap-general-xccdf-check-export"
            context="xccdf:Rule/xccdf:check/xccdf:check-export">
            <assert flag="ERROR"
                test="if( //xccdf:Value[@id eq current()/@value-id]/@type eq 'number' ) then //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'int' or //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'float' else true()"
                id="scap-general-xccdf-rule-value-binding-type-1">38-1</assert>
            <assert flag="ERROR"
                test="if( //xccdf:Value[@id eq current()/@value-id]/@type eq 'boolean' ) then //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'boolean' else true()"
                id="scap-general-xccdf-rule-value-binding-type-2">38-2</assert>
            <assert flag="ERROR"
                test="if( //xccdf:Value[@id eq current()/@value-id]/@type eq 'string' ) then //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'string' or //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'evr_string' or //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'version' or //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'ios_version' or //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'fileset_revision' or //*[@id eq (current()/following-sibling::xccdf:check-content-ref)[1]/@href]//*[@id eq current()/@export-name]/@datatype eq 'binary' else true()"
                id="scap-general-xccdf-rule-value-binding-type-3">38-3</assert>
        </rule>
        <rule id="scap-general-oval-def" context="oval-def:definition">
            <assert flag="ERROR"
                test="if( @class = 'compliance' or @class = 'inventory' or @class = 'patch' or @class = 'vulnerability' ) then exists(oval-def:metadata/oval-def:affected) else true()"
                id="scap-general-oval-metadata-affected-exist">56</assert>
            <assert flag="ERROR"
                test="every $m in oval-def:metadata/oval-def:affected satisfies if( count($m/following-sibling::oval-def:affected) gt 0 ) then $m/following-sibling::oval-def:affected[1]/@family eq $m/@family else true()"
                id="scap-general-oval-metadata-affected-family">58</assert>
            <assert flag="ERROR"
                test="if( oval-def:metadata/oval-def:affected and current()//oval-def:extend_definition ) then every $m in current()//oval-def:extend_definition satisfies not(exists(../oval-def:definition[@id eq $m/@definition_ref]/oval-def:metadata/oval-def:affected)) or (every $n in ../oval-def:definition[@id eq $m/@definition_ref]/oval-def:metadata/oval-def:affected satisfies exists(oval-def:metadata/oval-def:affected[@family eq $n/@family]) and count(../oval-def:definition[@id eq $m/@definition_ref]/oval-def:metadata/oval-def:affected) eq count(oval-def:metadata/oval-def:affected)) else true()"
                id="scap-general-oval-extended-def-family">59</assert>
            <assert flag="ERROR"
                test="if( not(exists(oval-def:metadata/oval-def:affected/@family)) ) then every $m in oval-def:criteria//oval-def:criterion satisfies namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#independent' else true()"
                id="scap-general-oval-definition-family-test-schema-1">60-1</assert>
            <assert flag="ERROR"
                test="if( exists(oval-def:metadata/oval-def:affected[@family eq 'ios']) ) then every $m in oval-def:criteria//oval-def:criterion satisfies namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#ios' or namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#independent' else true()"
                id="scap-general-oval-definition-family-test-schema-2">60-2</assert>
            <assert flag="ERROR"
                test="if( exists(oval-def:metadata/oval-def:affected[@family eq 'macos']) ) then every $m in oval-def:criteria//oval-def:criterion satisfies namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#macos' or namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#independent' else true()"
                id="scap-general-oval-definition-family-test-schema-3">60-3</assert>
            <assert flag="ERROR"
                test="if( exists(oval-def:metadata/oval-def:affected[@family eq 'unix']) ) then every $m in oval-def:criteria//oval-def:criterion satisfies namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#hpux' or namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#linux' or namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#solaris' or namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#unix' or namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#independent' else true()"
                id="scap-general-oval-definition-family-test-schema-4">60-4</assert>
            <assert flag="ERROR"
                test="if( exists(oval-def:metadata/oval-def:affected[@family eq 'windows']) ) then every $m in oval-def:criteria//oval-def:criterion satisfies namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#windows' or namespace-uri($m/ancestor::oval-def:oval_definitions//*[@id eq $m/@test_ref]) eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5#independent' else true()"
                id="scap-general-oval-definition-family-test-schema-5">60-5</assert>
            <assert flag="ERROR"
                test="if(exists(ancestor::scap:check-system-content[@content-type eq 'OVAL_VULNERABILITY'])) then (@class eq 'vulnerability' or @class eq 'patch') or ((@class eq 'inventory' or @class eq 'compliance') and exists(xcf:get-all-def-children(ancestor::oval-def:oval_definitions,current())[@class eq 'vulnerability'])) else true()"
                id="scap-general-oval-vulnerability-ref-inventory-compliance">63-2</assert>
            <assert flag="ERROR"
                test="if( @class eq 'patch' and exists(ancestor::scap:check-system-content[@content-type eq 'OVAL_PATCH']) and exists(current()//oval-def:extend_definition) ) then every $m in current()//oval-def:extend_definition satisfies current()/../oval-def:definition[@id eq $m/@definition_ref]/@class eq 'inventory' else true()"
                id="scap-general-oval-patch-ref-inventory">65-2</assert>
            <assert flag="WARNING"
                test="if( @class eq 'patch' ) then exists(current()//oval-def:reference) else true()"
                id="scap-general-oval-patch-ref">66</assert>
        </rule>
        <rule id="scap-general-oval-check" context="scap:check-system-content">
            <assert flag="ERROR"
                test="if( @content-type eq 'OVAL_COMPLIANCE' ) then exists(current()//oval-def:definitions/oval-def:definition[@class eq 'compliance']) else true()"
                id="scap-general-oval-compliance-required">61-1</assert>
            <assert flag="ERROR"
                test="if( @content-type eq 'OVAL_COMPLIANCE' ) then every $m in current()//oval-def:definitions/oval-def:definition satisfies $m/@class eq 'compliance' or $m/@class eq 'inventory' else true()"
                id="scap-general-oval-compliance-inventory">61-2</assert>
            <assert flag="ERROR"
                test="if( @content-type eq 'OVAL_COMPLIANCE' ) then every $m in current()//oval-def:definitions/oval-def:definition[@class eq 'inventory'] satisfies (some $n in current()//oval-def:definitions/oval-def:definition[@class eq 'compliance'] satisfies exists($n//oval-def:extend_definition[@definition_ref eq $m/@id])) else true()"
                id="scap-general-oval-compliance-ref-inventory">61-3</assert>
            <assert flag="ERROR"
                test="if( @content-type eq 'OVAL_VULNERABILITY' ) then exists(current()//oval-def:definitions/oval-def:definition[@class eq 'vulnerability' or @class eq 'patch']) else true()"
                id="scap-general-oval-vulnerability-required">63-1</assert>
            <assert flag="ERROR"
                test="if( @content-type eq 'OVAL_PATCH' ) then exists(current()//oval-def:definitions/oval-def:definition[@class eq 'patch']) else true()"
                id="scap-general-oval-patch-required">65-1</assert>
            <assert flag="ERROR"
                test="if( @content-type eq 'CPE_INVENTORY' ) then every $m in current()//oval-def:definition satisfies $m/@class eq 'inventory' else true()"
                id="scap-general-oval-inventory">67</assert>
        </rule>
    </pattern>
    <xsl:function xmlns:xcf="nist:scap:xslt:function"
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns="http://www.w3.org/1999/XSL/Transform" name="xcf:get-all-parents">
        <xsl:param name="doc"/>
        <xsl:param name="node"/>
        <xsl:sequence select="$node"/>
        <xsl:for-each select="$node//oval-def:extend_definition">
            <xsl:sequence
                select="xcf:get-all-parents($doc,ancestor::oval-def:oval_definitions//*[@id eq current()/@definition_ref])"
            />
        </xsl:for-each>
    </xsl:function>
    <xsl:function xmlns:xcf="nist:scap:xslt:function" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/XSL/Transform" name="xcf:get-all-def-children">
        <xsl:param name="doc" />
        <xsl:param name="node" />
        <xsl:sequence select="$node" />
        <xsl:for-each select="$doc//oval-def:extend_definition[@definition_ref eq $node/@id]/ancestor::oval-def:definition">
            <xsl:sequence select="xcf:get-all-def-children($doc,current())" />
        </xsl:for-each>
    </xsl:function>
    <xsl:function xmlns:xcf="nist:scap:xslt:function" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/XSL/Transform" name="xcf:get-all-external-vars">
        <xsl:param name="doc" />
        <xsl:param name="node" />
        <xsl:sequence select="$doc//oval-def:external_variable[@id eq $node/@var_ref]" />
        <xsl:for-each select="$doc//*[@id eq $node/@var_ref]//*[@var_ref]">
            <xsl:sequence select="xcf:get-all-external-vars($doc,current())" />
        </xsl:for-each>
    </xsl:function>
</schema>
