<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:sch="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2">
    <param xmlns="http://www.w3.org/1999/XSL/Transform" name="profile" />
    <param xmlns="http://www.w3.org/1999/XSL/Transform" name="datafiles_directory" />
    <ns prefix="xccdf" uri="http://checklists.nist.gov/xccdf/1.1"/>
    <ns prefix="xml" uri="http://www.w3.org/XML/1998/namespace"/>
    <ns prefix="oval-def" uri="http://oval.mitre.org/XMLSchema/oval-definitions-5"/>
    <ns prefix="oval-com" uri="http://oval.mitre.org/XMLSchema/oval-common-5"/>
    <ns prefix="scap" uri="http://scap.nist.gov/schema/data-stream/0.1"/>
    <ns prefix="cpe-dict" uri="http://cpe.mitre.org/dictionary/2.0"/>
    <ns prefix="xcf" uri="nist:scap:xslt:function"/>
    <ns prefix="nvd-config" uri="http://scap.nist.gov/schema/feed/configuration/0.1"/>
    <ns prefix="ocil" uri="http://scap.nist.gov/schema/ocil/2"/>
    <ns prefix="sch" uri="http://purl.oclc.org/dsdl/schematron"/>
    <pattern id="scap-additional-rules">
        <rule id="scap-unused-oval-rule" context="oval-def:definition">
            <assert flag="WARNING"
                test="if( exists(//scap:xccdf-content) ) then exists(ancestor::scap:check-system-content[@content-type eq 'OVAL_PATCH']) or exists(//xccdf:check-content-ref[@href eq current()/ancestor::scap:check-system-content/@id and (not(@name) or @name eq current()/@id)]) or exists(current()/ancestor::oval-def:oval_definitions//oval-def:extend_definition[@definition_ref eq current()/@id]) or exists(//cpe-dict:check[@href eq current()/ancestor::scap:check-system-content/@id and . eq current()/@id]) else true()"
                id="scap-unused-oval-assert">A15|oval-def:definition <sch:value-of select="@id"/></assert>
        </rule>
        <rule id="scap-cce-check-rule-1" context="xccdf:ident">
            <assert flag="WARNING"
                test="if(@system eq 'http://cce.mitre.org' or @system eq 'CCE') then . ne '' else true()"
                id="scap-cce-check-assert-1">A16|xccdf:Rule <sch:value-of select="ancestor::xccdf:Rule/@id"/></assert>
            <assert flag="ERROR"
                test="if(@system eq 'http://cce.mitre.org' or @system eq 'CCE') then matches(., '^CCE-\d+-\d$') else true()"
                id="scap-cce-check-assert-2">A17|<sch:value-of select="."/></assert>
            <assert flag="ERROR"
                test="if((@system eq 'http://cce.mitre.org' or @system eq 'CCE') and matches(., '^CCE-\d+-\d$')) then (sum(for $j in (for $i in reverse(string-to-codepoints(concat(substring(.,5,string-length(.)-6),substring(.,string-length(.),1))))[position() mod 2 = 0] return ($i - 48) * 2, for $i in reverse(string-to-codepoints(concat(substring(.,5,string-length(.)-6),substring(.,string-length(.),1))))[position() mod 2 = 1] return ($i - 48)) return ($j mod 10, $j idiv 10)) mod 10) eq 0 else true()"
                id="scap-cce-check-assert-3">A17|<sch:value-of select="."/></assert>
        </rule>
        <rule id="scap-cce-check-rule-2" context="oval-def:reference">
            <assert flag="WARNING"
                test="if(@source eq 'http://cce.mitre.org') then @ref_id ne '' else true()"
                id="scap-cce-check-assert-5">A16|oval-def:definition <sch:value-of select="ancestor::oval-def:definition/@id"/></assert>
            <assert flag="ERROR"
                test="if(@source eq 'http://cce.mitre.org') then matches(@ref_id, '^CCE-\d+-\d$') else true()"
                id="scap-cce-check-assert-6">A17|<sch:value-of select="@ref_id"/></assert>
            <assert flag="ERROR"
                test="if(@source eq 'http://cce.mitre.org' and matches(@ref_id, '^CCE-\d+-\d$')) then (sum(for $j in (for $i in reverse(string-to-codepoints(concat(substring(@ref_id,5,string-length(@ref_id)-6),substring(@ref_id,string-length(@ref_id),1))))[position() mod 2 = 0] return ($i - 48) * 2, for $i in reverse(string-to-codepoints(concat(substring(@ref_id,5,string-length(@ref_id)-6),substring(@ref_id,string-length(@ref_id),1))))[position() mod 2 = 1] return ($i - 48)) return ($j mod 10, $j idiv 10)) mod 10) eq 0 else true()"
                id="scap-cce-check-assert-7">A17|<sch:value-of select="@ref_id"/></assert>
        </rule>
        <rule id="scap-check-system-content-match-rule" context="scap:check-system-content">
            <assert flag="ERROR"
                test="if(matches(@content-type,'^(OVAL_COMPLIANCE|OVAL_PATCH|CPE_INVENTORY|OVAL_VULNERABILITY)$')) then exists(oval-def:oval_definitions) else true()"
                id="scap-check-system-content-match-assert-1">A18</assert>
            <assert flag="ERROR"
                test="if(matches(@content-type,'^(OCIL_QUESTIONS)$')) then exists(ocil:ocil) else true()"
                id="scap-check-system-content-match-assert-1">A18</assert>
        </rule>
        <rule id="scap-oval-tests" context="oval-def:tests/*">
            <assert flag="INFO"
                test="exists(document(concat($datafiles_directory,'/validation_program_oval_test_types.xml'))/test_types/test_type[@namespace eq namespace-uri(current()) and @name eq local-name(current())])"
                id="scap-oval-tests-validation-program-test-types">A21|OVAL test <sch:value-of select="@id"/></assert>
        </rule>
        
    </pattern>
</schema>
